class Piece
  attr_accessor :pos, :board, :color

  def initialize(pos = nil, board = nil, color = nil)
    @pos = pos
    @board = board
    @color = color
  end

  def moves
    positions = []

    deltas.each do |delta|
      possible_moves = potential_moves(delta)
      positions.concat(possible_moves) #unless possible_moves.nil?
    end

    positions
  end

  def update_piece(pos)
    self.pos = pos
  end

  def next_pos(pos, delta)
    x, y = pos
    dx, dy = delta

    [x + dx, y + dy]
  end

  def valid_pos?(pos)
    board.on_board?(pos) && (board[pos].nil? || board[pos].color != color)
  end

  def move_into_check?(possible_pos)
    new_board = board.dup
    new_board.move!(pos, possible_pos)
    new_board.in_check?(color)
  end

  def valid_moves
    moves.reject { |move| move_into_check?(move) }
  end

  def deltas
    self.class::DELTAS
  end

  def dup(new_board)
    self.class.new(pos, new_board, color)
  end
end
